/* 
 * load distances from france.dat
 * into a square matrix
 * store towns GPS into a tab
 * Dijkstra on edges existing according to a threshold
 */

#include <stdio.h>


// load Distances
// size (TOWNS+1) * (TOWNS+1)
// pour numerotation à partir de 1
#define INFINI  99999
#define MAXDIST 480
#define TOWNS 24
int Distances[TOWNS+1][TOWNS+1];

struct {
	char name[128];
	double lat, lon;
} Gps[100];

void readDistances (char *filename)
{
	int i, j, k;
	int distance;
	FILE *fp = fopen(filename, "r");

	if (!fp) exit(-1);

	for (j=1; j<=TOWNS; j++) {
		Distances[j][j] = 0;
		for (i=1; i<j; i++) {
			int v;
			fscanf(fp, "%d", &v);
			Distances[j][i] = Distances[i][j] = (v < MAXDIST) ? v : INFINI ;
			
		}
	}
	fclose(fp);
}

void readTowns(char *filename)
{
	FILE *fp = fopen(filename, "r");
	int i;

	if (!fp) exit(-1);
	for (i=1; i<=TOWNS; i++) 
		fscanf(fp, "%s%lf%lf", Gps[i].name, &(Gps[i].lat), &(Gps[i].lon));
	fclose(fp);
}

void dijkstraTowns(int som0, int D[TOWNS+1], int C[TOWNS+1]) 
{
	/* E is a tab of size #nodes. 
	 * E[i] == 0 if i not in E,
	 * E[i] == 1 else
	 *
	 * D is a tab of size #nodes.
	 * at the end, D[i] equals to min distance
	 * from s0 to i
	 * C is predecessors tab
	 */
	int som, succ, poids;
	int somMini, mini;
	int E[TOWNS+1];

	/* initialisation */
	for (som=1; som<=TOWNS; som++) {
		D[som] = INFINI;
		C[som] = som0;
		E[som] = 0;
	}
	D[som0] = 0;

	// it is your work now !!
	
}


void printPath(char *filename, int t1, int t2, int C[TOWNS+1])
{
	FILE *fp = fopen(filename, "w");

	int t = t2;
	do {
		fprintf(fp, "%s %lf %lf\n", Gps[t].name, Gps[t].lat, Gps[t].lon);
		t = C[t];
	} while (t != t1);
	fprintf(fp, "%s %lf %lf\n", Gps[t1].name, Gps[t1].lat, Gps[t1].lon);
	
	fclose(fp);
}


// tests
main() {
	int som, dep = 3 /* Brest */, arr = 17 /* Nice */;
	int D[TOWNS+1];
	int C[TOWNS+1];

	readDistances("distances.dat");
	readTowns("villes.dat");

 	// Dijkstra
	dijkstraTowns(dep, D, C);
	printf("total distance : %d\n", D[arr]);

	printPath("trajet.dat", dep /* Brest */, arr /* Nice */, C);

	// run gnuplot to get the result into dijkstra.gif
	system("gnuplot plot.script");


}

